/*************************************************************************** 
 * RT2400 SourceForge Project - http://rt2400.sourceforge.net              * 
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  * 
 *   it under the terms of the GNU General Public License as published by  * 
 *   the Free Software Foundation; either version 2 of the License, or     * 
 *   (at your option) any later version.                                   * 
 *                                                                         * 
 *   This program is distributed in the hope that it will be useful,       * 
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 *   GNU General Public License for more details.                          * 
 *                                                                         * 
 *   You should have received a copy of the GNU General Public License     * 
 *   along with this program; if not, write to the                         * 
 *   Free Software Foundation, Inc.,                                       * 
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                         * 
 *   Licensed under the GNU GPL                                            * 
 *   Original code supplied under license from RaLink Inc, 2003.           * 
 ***************************************************************************/ 

 /*************************************************************************** 
 *      Module Name: cardselect.h
 *              
 *      Abstract: Implement card select dialog 
 *              
 *      Revision History: 
 *      Who             When            What 
 *      --------        -----------     ----------------------------- 
 *      PaulL           22nd Jan 02     Created
 *      MarkW           9th  Feb 04     Baseline of code
 ***************************************************************************/ 


#ifndef CARDSELECT_H
#define CARDSELECT_H

#include <qvariant.h>
#include <qdialog.h>
#include <rt_tool.h>

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QLabel;
class QListView;
class QListViewItem;
class QPushButton;


class CardSelect : public QDialog
{ 
	Q_OBJECT

public:
	CardSelect( int Socket_Id = 0, PRT_DEVICE_ADAPTER prtAdapter = NULL, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~CardSelect();

	QPushButton* OkPushButton;
	QListView* AdapterListView;
	QLabel* TextLabel1;
	QString    device;
	const char	*Get_Device_Name();

public slots:	

	virtual void AdapterListView_doubleClicked();
	virtual void OkPushButton_Clicked();
};

#endif // CARDSELECT_H
