/*************************************************************************** 
 * RT2400 SourceForge Project - http://rt2400.sourceforge.net              * 
 *                                                                         * 
 *   This program is free software; you can redistribute it and/or modify  * 
 *   it under the terms of the GNU General Public License as published by  * 
 *   the Free Software Foundation; either version 2 of the License, or     * 
 *   (at your option) any later version.                                   * 
 *                                                                         * 
 *   This program is distributed in the hope that it will be useful,       * 
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 *   GNU General Public License for more details.                          * 
 *                                                                         * 
 *   You should have received a copy of the GNU General Public License     * 
 *   along with this program; if not, write to the                         * 
 *   Free Software Foundation, Inc.,                                       * 
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                         * 
 *   Licensed under the GNU GPL                                            * 
 *   Original code supplied under license from RaLink Inc, 2003.           * 
 ***************************************************************************/ 

 /*************************************************************************** 
 *      Module Name: countryform.h
 *              
 *      Abstract: Implement country region select dialog 
 *              
 *      Revision History: 
 *      Who             When            What 
 *      --------        -----------     ----------------------------- 
 *      PaulL           22nd Jan 02     Created
 *      MarkW           9th  Feb 04     Baseline of code
 ***************************************************************************/ 


#ifndef _COUNTRYFROM_H
#define _COUNTRYFROM_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QLabel;
class QPushButton;
class QRadioButton;

class CountryForm : public QDialog
{ 
	Q_OBJECT

public:
	CountryForm( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~CountryForm();

	QLabel* InfoTextLabel;
	QPushButton* OkPushButton;
	QPushButton* CancelPushButton;
	QButtonGroup* SelectButtonGroup;
	QRadioButton* ISRAELRadioButton;
	QRadioButton* ICRadioButton;
	QRadioButton* ETSIRadioButton;
	QRadioButton* MKKRadioButton;
	QRadioButton* MKK1RadioButton;
	QRadioButton* SPAINRadioButton;
	QRadioButton* FCCRadioButton;

	int GetRegionID();
};

#endif //_COUNTRYFROM_H

